/*!
  * Licensed Materials - Property of IBM
  * 5725N95, 5725P55, 5725N96
  * (C) Copyright IBM Corp. 1999, 2014.
  * US Government Users Restricted Rights- Use, duplication or disclosure
  * restricted by GSA ADP Schedule Contract with IBM Corp.
 */

 /* $Id$ */
 
AssessmentUI =
{
	currentPage:0,
	buttons:{},
	backwardsNavigationAllowed: true,
	pages: 1,
	initPages: false,
	tocPos : {left : 0, top: 0},
	tocWidth: 200,
	init:function() {
		AssessmentEngine.questionsPerPage = 1;
		AssessmentEngine.events.timerUpdated.subscribe(AssessmentUI.updateTimer);
		var $ = jQuery;
		$("#btn-toc-a").off('click').on('click',  $.proxy(this.showPages, this));
		if(this.backwardsNavigationAllowed) {
			$("#assess_btn_prev").off('click').on('click', $.proxy(this.previous, this));
		}else {
			$("#assess_btn_prev").off('click');
		}
		$("#asses_btn_next").off('click').on('click', $.proxy(this.next, this));
		$("#btnscore").off('click').on('click',  $.proxy(this.score, this));
		jQuery("#assessPages").empty();
		
		$("#totalPage")[0].innerHTML = this.pages;
		// show first page
		this.page(1);
		vc.events.group_loaded.unsubscribe(AssessmentUI.init, AssessmentUI);
	},
	page:function(p)
	{
		var $ = jQuery;
		
		AssessmentEngine.currentPage = p;
		$("#page" + this.currentPage).css('visibility', 'hidden');
		//#56684: Hidden all object tags that cause side effect to hotspot element 
		$("#page" + this.currentPage).find( "div[id^='mc'] object" ).css( "display", "none" );
		
		$("#page" + p).css('visibility', 'visible');
		$("#page" + p).find( "div[id^='mc'] object" ).css( "display", "inline" );
		$("#current").html(p);
		if(p>1) {
			$("#content").scrollTop(0);
		}
				
		$("#page_"+this.currentPage).parent().removeClass("nodeAccessed");
		$("#page_"+p).parent().addClass("nodeAccessed");
		if($("#assessPageContainer").css('display') != "none") {
			$("#assessPageContainer").css({left: this.tocPos.left, top: this.tocPos.top}).slideUp('slow');
		}
		this.currentPage = p;
		this.updateButtons();
	},
	
	updateButtons: function() {
		//can go back
		var navigable = (this.backwardsNavigationAllowed && this.currentPage > 1 ), addedClz, removedClz;
		addedClz = navigable ? "prev-btn-active" : "assess-btn-disabled";
		removedClz = navigable ? "assess-btn-disabled" : "prev-btn-active";
		
		jQuery("#assess_btn_prev").addClass(addedClz).removeClass(removedClz);
		//can go next
		navigable = this.currentPage < this.pages;
		addedClz = navigable ? "next-btn-active" : "assess-btn-disabled";
		removedClz = navigable ? "assess-btn-disabled" : "next-btn-active";
		jQuery("#asses_btn_next").addClass(addedClz).removeClass(removedClz);
	},
	previous:function()
	{
		if ( this.currentPage > 1 )
		{
			this.page(this.currentPage-1);
		}
	},
	next:function()
	{
		var ae = AssessmentEngine;
		if ( this.currentPage != this.pages )
		{
			if ((!ae.assessment.allowSkipQuestions && !ae.assessment.allowBackwardsNavigation) && !ae.isPageCompleted(this.currentPage))
			{
				// not allowed to navigate backwards and not allowed to skip and the page has unanswered questions
				alert(ae.skippedNotAllowedMsg);
			}
			else
			{
				this.page(this.currentPage+1);
			}
		}
	},
	showPages: function(e){
		if(!this.initPages) {
			var $assessContainer = jQuery("#assessPages");
			var frag = document.createDocumentFragment();
			var d = document.createElement("div"), dCloned;
			d.setAttribute("class", "assess_page");
			var s = document.createElement("span");
			for(var i = 1; i <= this.pages; i++) {
				s.innerText = "Page " + i;
				s.setAttribute("id", "page_" + i);
				dCloned = d.cloneNode();
				dCloned.appendChild(s.cloneNode(true));
				frag.appendChild(dCloned);
			}			
			$assessContainer.append(frag);
			var me = this;
			jQuery("#page_"+me.currentPage).parent().addClass("nodeAccessed");
			$assessContainer.on("click", "div" , function(e) {								
				var pageId = parseInt(e.currentTarget.firstChild.id.split("_")[1]);
				var accessible = true;
				if(!AssessmentUI.backwardsNavigationAllowed) {
					if(pageId < AssessmentUI.currentPage) {
						accessible = false;
					}
				}
				if(accessible) {
					me.page(pageId);
				}
			});
			this.initPages = true;
			var $btnToc = jQuery("#btn-toc-a");
			var btnTocPos = $btnToc.offset();
			this.tocPos.left = btnTocPos.left + ($btnToc.width()/2) - (this.tocWidth/2);
			this.tocPos.top = btnTocPos.top + $btnToc.height() + 29;
		}
		jQuery("#assessPageContainer").css({left: this.tocPos.left, top: this.tocPos.top}).slideToggle('slow');
	},
	score: function() {
		jQuery("#assessPageContainer").hide();
		AssessmentEngine.score();
	},
	updateTimer : function()
	{
		if (AssessmentEngine.remaining > 0)
		{
			var elm = jQuery("#tmrval");
			if (elm.length > 0)
			{
				elm.html(AssessmentUI.formatDisplayTime(AssessmentEngine.remaining));
			}
		}
	},
	formatDisplayTime : function(r) 
	{
		var h = 0;
		var m = 0;
		var s = 0;
		
		if ( r < 60 ) 
		{
			s = r;
		}
		else if ( r < 3600 ) 
		{
			m = Math.floor(r / 60);
			s = (r - (m * 60));
		}
		else {
			h = Math.floor( r / 3600 );
			m = Math.floor(( r - (h * 3600)) / 60 );
			s = (r - ( h * 3600 ) - ( m * 60 ));
		}
		
		if (m < 10) m = "0"+m;
		if (s < 10) s = "0"+s;
		
		return h+":"+m+":"+s;
	}
};
//an assessment may be launched out of course/module... context.
if(typeof(vc) != "undefined"){
	vc.events.group_loaded.subscribe(AssessmentUI.init, AssessmentUI, true);
}
